#!/usr/bin/php
<?
//This program converts the pictures to something an LCD can understand


//Call this to convert a picture to custom characters. It'll output as 
//much characters as necessary, happily more than the 8 available in the
//HD44780: take care about that.

//To generate grays: call this function twice on the same image, once with n=0
//and once with n=2. Then, in the avr code, alternate between sending the two
//images.

//Function returns the number of custom characters used, multiply by 5 to get the
//number of chars used.

function do_convert($i, $n) {
    $ret=0;
    for ($cx=0; $cx<8; $cx++) {
	for ($cy=0; $cy<2; $cy++) {
	    $r=0;
	    $e="  ";
	    for ($x=0; $x<5; $x++) {
		$t=0;
		for ($y=0; $y<8; $y++) {
		    $t<<=1;
		    $rx=($cx*6)+$x;
		    $ry=($cy*9)+$y;
		    if (($rx<imagesx($i)) && ($ry<imagesy($i))){
			$col=imagecolorsforindex($i,imagecolorat($i,$rx,$ry));
			if ($col["green"]<85) $t|=1;
			if (($col["green"]<170) && ($n==(($rx+$ry)&1))) $t|=1;
		    }
		}
		$r+=$t;
		$e.=sprintf("0x%02X",$t);
		$e.=",";
	    }
    	    if ($r!=0 && $r!=(255*5)) {
		echo "$e //@ $cx,$cy\n";
		$ret++;
	    }
	}
    }
    return $ret;
}

//header
echo "unsigned char custom_chars".$n."[] PROGMEM={\n";

$pos=0;
$defs=array();

//Image for girl in scroller. This is a grayscale image.
$i=imagecreatefrompng("girl-resc.png");
imagetruecolortopalette($i,0,255);
echo "// girl-resc.png, b0\n";
$defs["CUST_GIRL_RESC0"]=$pos;
$pos+=do_convert($i,0)*5;
echo "// girl-resc.png, b1\n";
$defs["CUST_GIRL_RESC1"]=$pos;
$pos+=do_convert($i,1)*5;

//Animated 2x2-chars dancing girl
$defs["ANIM_GIRL"]=$pos;
for ($n=0; $n<30; $n++) {
    $i=imagecreatefrompng("anim/dg-$n.png");
    imagetruecolortopalette($i,0,255);
    echo "// anim/dg-$n.png\n";
    $ri=imagecreate(11,17);
    imagecopy($ri,$i,0,0,3,1,11,17);
    $pos+=do_convert($ri,(n&1))*5;
}

//footer
echo "  };\n\n";

//output the positions of the various images
foreach($defs as $k=>$n) {
    echo "#define $k $n\n";
}


?>